echo off
rem
rem The default directory where all the servers sit is the \MB directory so
rem go there.

cd \MB

rem before we can use thje MAIL or BULLETIN files for mail distribution, we
rem have to "doctor" them since SMTP does not like any text line longer than
rem 128 characters, so we word wrap all lines to 80 characters maximum with
rem the program ROUND.COM

if exist mail.txt goto domail
goto nomail
:domail
round mail.txt mail.tmp
del mail.txt

smtpi mail.tmp smtpmail.lst g0bsx.ampr.org GB7BSX

rem The parameters for the smtpi.com file are as follows:
rem 1. the filename of the file into which the mailbox ahs exported all the
rem    mail to be distributed. Note I use a temp file created by ROUND.COM
rem 2. the filename of the list of host, callsign and selection specs desired
rem    for the distribution of MAIL.
rem 3. the host id of the TCP/IP system that interfaces to the mailbox.
rem 4. the CALLSIGN of the mailbox.
rem
rem ONLY do the bulletin export in the early hours and then ONLY once per
rem hour.

:nomail
rem timer -ih 0106
rem if errorlevel 1 goto timeok
rem goto import
:timeok
if exist bulls.txt goto dobulls
goto nobulls
:dobulls
round bulls.txt bulls.tmp
del bulls.txt

smtpi bulls.tmp smtpbull.lst g0bsx.ampr.org GB7BSX

rem The arguments for the program smtpi.com are as follows:
rem 1. The filename of the file use my the mailbox to put the exported
rem    INTO. In this case it is the .TMP file created by ROUND.COM.
rem 2. The filename of the list of calls and hosts and selection parameters
rem    pertaining to BULLETINS.
rem 3. the hostid of the SMTP TCPIP system that the mailbox is interfaced to.
rem 4. the CALLSIGN of the mailbox.

:nobulls
:import
smtpx import.txt \mb\smtpxdel.txt GB7BSX g0bsx.ampr.org

rem The parameters of the SMTPX.COM program are the filename of the text file
rem into which will be placed mailbox message for import INTO the mailbox, the
rem filename containing the conditions for delivery of mail via the SMTP and
rem TCPIP mailbox system, the Mailbox Callsign and the TCPIP host id.
rem NOTE: the FULL pathname of the delivery condition filename MUST be given.
rem
rem Since SMTP don't like long lines, ROUND this output file as well just
rem to be on the safe side!

if exist import.txt goto roundit
goto bpqnodes

:roundit
round import.txt import.tmp
copy import.tmp import.txt

rem I always leave the .TMP files in case something fails so that I can have
rem a look at them and perhaps re-cycle them if needs be.

:bpqnodes
rem  update BPQ nodes list every 3 hours.

timer -th 3
if errorlevel 1 goto datime
goto doage
:datime
cd \bpq
bpqnodes

rem If you do not run NOS mailbox and bulletin areas, commecnt out the next
rem section.
rem Age the bulletins in the SMTP mailbox once a day after between 0100
rem and 0200

:doage
cd\spool
rem Change to a different directory sibnce I want to use different time data
\mb\timer -ih 1717
if errorlevel 1 goto smtpage
goto end
:smtpage

rem see documentation on AGE.COM in the file AGE.DOC.
\mb\age
:end
cd \bbs

rem you MUST change back to the BBS directory for SERVER to work another time!
rem
rem *** The END *** ((phew!))
